# PrestaShop\Module\PrestaConnector\pol\api\lib\ClientsApi

All URIs are relative to https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api/WebConnect, except if the operation defines another base path.

| Method | HTTP request | Description |
| ------------- | ------------- | ------------- |
| [**clientsDeleteClient()**](ClientsApi.md#clientsDeleteClient) | **DELETE** /Clients/Client | Marque un compte client pour sa suppression. |
| [**clientsGetBon()**](ClientsApi.md#clientsGetBon) | **GET** /Clients/Bon | Obtient un bon en fonction de son code |
| [**clientsGetBons()**](ClientsApi.md#clientsGetBons) | **GET** /Clients/Bons | Obtient une liste de bons |
| [**clientsGetCartePrePaye()**](ClientsApi.md#clientsGetCartePrePaye) | **GET** /Clients/CartePrePaye | Obtient une carte prépayée en fonction de son code |
| [**clientsGetCartePrePayes()**](ClientsApi.md#clientsGetCartePrePayes) | **GET** /Clients/CartePrePayes | Obtient une liste des cartes prépayées |
| [**clientsGetClient()**](ClientsApi.md#clientsGetClient) | **GET** /Clients/Client | Obtient un client précis |
| [**clientsGetClients()**](ClientsApi.md#clientsGetClients) | **GET** /Clients/Clients | Obtient les clients |
| [**clientsGetDiffusion()**](ClientsApi.md#clientsGetDiffusion) | **GET** /Clients/Diffusion | Obtient les listes de diffusion des clients |
| [**clientsPostBon()**](ClientsApi.md#clientsPostBon) | **POST** /Clients/Bon | Crée un nouveau bon |
| [**clientsPostClient()**](ClientsApi.md#clientsPostClient) | **POST** /Clients/Client | Créer un nouveau client ou modifie un client existant s&#39;il est déjà trouvé dans la base de données. |
| [**clientsPutClientCarte()**](ClientsApi.md#clientsPutClientCarte) | **PUT** /Clients/ClientCarte | Modifie le nombre de points |


## `clientsDeleteClient()`

```php
clientsDeleteClient($id): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClient
```

Marque un compte client pour sa suppression.

Marque un compte client pour sa suppression.    La suppression réelle ne sera effectuée qu'une fois le compte ne sera plus du tout utilisé par le système, en attendant, il possédera l'état 'quarantaine' et sera vidé de toutes informations personnelles (nom, prénom, adresse mail, téléphone, ...)

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ClientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClientId(); // MetierClientWebConnectClientId | Identifiants du compte client à marque pour suppression

try {
    $result = $apiInstance->clientsDeleteClient($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->clientsDeleteClient: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **id** | [**MetierClientWebConnectClientId**](../Model/.md)| Identifiants du compte client à marque pour suppression | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClient**](../Model/MetierClientWebConnectClient.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `clientsGetBon()`

```php
clientsGetBon($code_bon): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierBonWebConnectBonClient
```

Obtient un bon en fonction de son code

Obtient un bon en fonction de son code

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ClientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$code_bon = 'code_bon_example'; // string | Code du bon à obtenir

try {
    $result = $apiInstance->clientsGetBon($code_bon);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->clientsGetBon: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **code_bon** | **string**| Code du bon à obtenir | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierBonWebConnectBonClient**](../Model/MetierBonWebConnectBonClient.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `clientsGetBons()`

```php
clientsGetBons($derniere_modif_date, $pager): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultMetierBonWebConnectBonClient
```

Obtient une liste de bons

Obtient une liste de bons

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ClientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$derniere_modif_date = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Date de la dernière modification des bons à rétribuer
$pager = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\Pager(); // Pager | Configuration de la sortie d'un résultat      Une documentation complémentaire est disponible à l'adresse [/api?doc=WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect.Pager)

try {
    $result = $apiInstance->clientsGetBons($derniere_modif_date, $pager);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->clientsGetBons: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **derniere_modif_date** | **\DateTime**| Date de la dernière modification des bons à rétribuer | [optional] |
| **pager** | [**Pager**](../Model/.md)| Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) | [optional] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultMetierBonWebConnectBonClient**](../Model/PagedResultMetierBonWebConnectBonClient.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `clientsGetCartePrePaye()`

```php
clientsGetCartePrePaye($code_carte): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierCPCarteWebConnectCartePrePayeeClient
```

Obtient une carte prépayée en fonction de son code

Obtient une carte prépayée en fonction de son code

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ClientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$code_carte = 'code_carte_example'; // string | Code de la carte prépayée à obtenir

try {
    $result = $apiInstance->clientsGetCartePrePaye($code_carte);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->clientsGetCartePrePaye: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **code_carte** | **string**| Code de la carte prépayée à obtenir | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierCPCarteWebConnectCartePrePayeeClient**](../Model/MetierCPCarteWebConnectCartePrePayeeClient.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `clientsGetCartePrePayes()`

```php
clientsGetCartePrePayes($derniere_modif_date, $pager): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultMetierCPCarteWebConnectCartePrePayeeClient
```

Obtient une liste des cartes prépayées

Obtient une liste des cartes prépayées

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ClientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$derniere_modif_date = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Date de la dernière modification des cartes prépayées
$pager = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\Pager(); // Pager | Configuration de la sortie d'un résultat      Une documentation complémentaire est disponible à l'adresse [/api?doc=WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect.Pager)

try {
    $result = $apiInstance->clientsGetCartePrePayes($derniere_modif_date, $pager);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->clientsGetCartePrePayes: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **derniere_modif_date** | **\DateTime**| Date de la dernière modification des cartes prépayées | [optional] |
| **pager** | [**Pager**](../Model/.md)| Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) | [optional] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultMetierCPCarteWebConnectCartePrePayeeClient**](../Model/PagedResultMetierCPCarteWebConnectCartePrePayeeClient.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `clientsGetClient()`

```php
clientsGetClient($id): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClient
```

Obtient un client précis

Obtient un client précis

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ClientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClientId(); // MetierClientWebConnectClientId | Identifiants du client

try {
    $result = $apiInstance->clientsGetClient($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->clientsGetClient: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **id** | [**MetierClientWebConnectClientId**](../Model/.md)| Identifiants du client | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClient**](../Model/MetierClientWebConnectClient.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `clientsGetClients()`

```php
clientsGetClients($filtre_client, $pager): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultMetierClientWebConnectClient
```

Obtient les clients

Obtient les clients

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ClientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$filtre_client = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectFiltreClient(); // MetierClientWebConnectFiltreClient | Structure représentant un filtage des clients
$pager = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\Pager(); // Pager | Configuration de la sortie d'un résultat      Une documentation complémentaire est disponible à l'adresse [/api?doc=WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect.Pager)

try {
    $result = $apiInstance->clientsGetClients($filtre_client, $pager);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->clientsGetClients: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **filtre_client** | [**MetierClientWebConnectFiltreClient**](../Model/.md)| Structure représentant un filtage des clients | [optional] |
| **pager** | [**Pager**](../Model/.md)| Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) | [optional] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultMetierClientWebConnectClient**](../Model/PagedResultMetierClientWebConnectClient.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `clientsGetDiffusion()`

```php
clientsGetDiffusion(): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierCliDiffusionWebConnecListDiffusionId[]
```

Obtient les listes de diffusion des clients

Obtient les listes de diffusion des clients

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ClientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);

try {
    $result = $apiInstance->clientsGetDiffusion();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->clientsGetDiffusion: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierCliDiffusionWebConnecListDiffusionId[]**](../Model/MetierCliDiffusionWebConnecListDiffusionId.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `clientsPostBon()`

```php
clientsPostBon($metier_bon_web_connect_bon_client_updateable): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierBonWebConnectBonClient
```

Crée un nouveau bon

Crée un nouveau bon

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ClientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$metier_bon_web_connect_bon_client_updateable = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierBonWebConnectBonClientUpdateable(); // \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierBonWebConnectBonClientUpdateable | Bon à créer  (bon)

try {
    $result = $apiInstance->clientsPostBon($metier_bon_web_connect_bon_client_updateable);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->clientsPostBon: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **metier_bon_web_connect_bon_client_updateable** | [**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierBonWebConnectBonClientUpdateable**](../Model/MetierBonWebConnectBonClientUpdateable.md)| Bon à créer  (bon) | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierBonWebConnectBonClient**](../Model/MetierBonWebConnectBonClient.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: `application/json`
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `clientsPostClient()`

```php
clientsPostClient($metier_client_web_connect_client_updateable): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClient
```

Créer un nouveau client ou modifie un client existant s'il est déjà trouvé dans la base de données.

Créer un nouveau client ou modifie un client existant s'il est déjà trouvé dans la base de données.    Les champs non précisés ou nuls ne provoquent aucune modification.

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ClientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$metier_client_web_connect_client_updateable = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClientUpdateable(); // \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClientUpdateable | Client  (client)

try {
    $result = $apiInstance->clientsPostClient($metier_client_web_connect_client_updateable);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->clientsPostClient: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **metier_client_web_connect_client_updateable** | [**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClientUpdateable**](../Model/MetierClientWebConnectClientUpdateable.md)| Client  (client) | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClient**](../Model/MetierClientWebConnectClient.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: `application/json`
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `clientsPutClientCarte()`

```php
clientsPutClientCarte($id, $metier_client_web_connect_carte_fidelite_modification, $code_carte): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClient
```

Modifie le nombre de points

Modifie le nombre de points

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ClientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClientId(); // MetierClientWebConnectClientId | Identifiants du client
$metier_client_web_connect_carte_fidelite_modification = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectCarteFideliteModification(); // \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectCarteFideliteModification | Client  (carteModification)
$code_carte = 'code_carte_example'; // string | Code de la carte client à modifier. Si non précisée, la première carte valide dans le magasin de référence sera utilisée, à défaut, la première carte trouvée.

try {
    $result = $apiInstance->clientsPutClientCarte($id, $metier_client_web_connect_carte_fidelite_modification, $code_carte);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->clientsPutClientCarte: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **id** | [**MetierClientWebConnectClientId**](../Model/.md)| Identifiants du client | |
| **metier_client_web_connect_carte_fidelite_modification** | [**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectCarteFideliteModification**](../Model/MetierClientWebConnectCarteFideliteModification.md)| Client  (carteModification) | |
| **code_carte** | **string**| Code de la carte client à modifier. Si non précisée, la première carte valide dans le magasin de référence sera utilisée, à défaut, la première carte trouvée. | [optional] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectClient**](../Model/MetierClientWebConnectClient.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: `application/json`
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)
